#include <pards/SyncList.h>

int main()
{
  void generator(SyncList<int>*);
  void consumer(SyncList<int>*);

  pards_init();

  SyncList<int> *a;
  a = new SyncList<int>;

  SPAWN(generator(a));
  SPAWN(consumer(a));

  pards_finalize();
}


void generator(SyncList<int> *a)
{
  int i;
  SyncList<int> *current, *nxt;
  current = a;

  for(i = 0; i < 10; i++){
    current->write(i);
    printf("writer:value = %d\n",i);
    nxt = new SyncList<int>;
    current->writecdr(nxt);
    current = nxt;
    sleep(1);
  }
  current->write(i);
  printf("writer:value = %d\n",i);
  current->writecdr(0);
}

void consumer(SyncList<int> *a)
{
  SyncList<int> *current,*prev;
  current = a;

  while(1){
    printf("reader:value = %d\n",current->read());
    prev = current;
    current = current->readcdr();
    delete prev;
    if(current == 0) break;
  }
}
    
